import React,{Fragment} from 'react';
import {Button, Icon, Input, message, Popconfirm} from 'antd';
export default class UnitInput extends React.Component{
  constructor(props){
    super(props);
    this.state={
      value:undefined,
      editStatus:false
    }
  }
  inputVal;
  editStatusToggle=(boolean)=>{
    this.setState({
      editStatus:boolean
    })
  }
  save=()=>{
    if(this.props.config.pattern.test(this.inputVal)){
      this.setState({
        value:this.inputVal,
        editStatus:false,
      });
      this.props.config.getOutput(this.inputVal);
    }else {
      message.error('输入有误')
    }
  };
  cancel=()=>{
    this.setState({
      defaultValue:this.state.value,
      editStatus:false
    })
  };
  componentDidMount() {
    this.setState({
      value : this.props.value
    })
  }
  getValue=(e)=>{
    this.inputVal = e.target.value
  };
  render() {
    return(
      <Fragment>
        {
          (()=>{
            if(!this.state.editStatus){
              return <span>{this.state.value}  <Icon onClick={()=>this.editStatusToggle(true)} type="edit" /> <i className="ml-20" style={{fontSize:'12px'}}>{this.props.config.tips}</i>
                {
                  (()=>{
                    if(this.props.config.removeBd){
                      return <Popconfirm title="确定解绑?" okText="是" onConfirm={this.props.config.removeBd} cancelText="否"><a className='ml-20'>解绑</a></Popconfirm>
                    }
                  })()
                }
                </span>
            }else {
              return <div>
                        <Input style={{width:'34%'}} placeholder={this.props.placeholder||'请输入...'} onChange={this.getValue} defaultValue={this.state.value}/>
                        <a className="ml-10 mr-10" onClick={this.save}>保存</a>
                        <a onClick={this.cancel}>取消</a>
                        <i className="ml-20" style={{fontSize:'12px'}}>{this.props.config.tips}</i>
                     </div>
            }
          })()
        }
      </Fragment>
    )
  }
}
