import React from 'react';
import ReactDOM from 'react-dom';
import { HashRouter } from 'react-router-dom';

// 载入默认全局样式 normalize 、.clearfix 和一些 mixin 方法等
import './style/antd-loader.less'

import '@alifd/next/reset.scss';
import './style/public.scss';

import router from './router';
require('./action');

const ICE_CONTAINER = document.getElementById('ice-container');

if (!ICE_CONTAINER) {
  throw new Error('当前页面不存在 <div id="ice-container"></div> 节点.');
}

ReactDOM.render(
  <HashRouter>{router()}</HashRouter>,

  ICE_CONTAINER
);
