/**
 * 定义应用路由
 */
import { Switch, Route,HashRouter,hashHistory } from 'react-router-dom';
import React from 'react';

import BasicLayout from './layouts/BasicLayout';
import LoginLayout from "./layouts/BasicLayout/LoginLayout";

// 按照 Layout 归类分组可以按照如下方式组织路由
const router = () => {
  return (
    <HashRouter history={hashHistory}>
      <Switch>
        <Route path="/login" component={LoginLayout} />
        <Route path="/" component={BasicLayout} />
      </Switch>
    </HashRouter>
    
  );
};

export default router;
